package com.keyboard.bubble.skin.keyboard.myada;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.keyboard.bubble.skin.keyboard.R;
import com.keyboard.bubble.skin.keyboard.bean.ChildBean;
import com.keyboard.bubble.skin.keyboard.utils.MyUtils;
import com.keyboard.bubble.skin.keyboard.mylistener.CancelLikeCallback;
import com.keyboard.bubble.skin.keyboard.ui.SetkeyboardActivity;

import java.util.ArrayList;
import java.util.List;

public class AdapterLike extends RecyclerView.Adapter<AdapterLike.ForYouViewHolder> {

    private Context mContext;
    private List<ChildBean> mList = new ArrayList<>();

    private CancelLikeCallback mCallBack;

    public AdapterLike(Context context) {
        mContext = context;
    }

    public void setForYouList(List<ChildBean> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setRemoveLike(CancelLikeCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.item_like, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        ChildBean childBean = mList.get(position);
        String thumbGif = childBean.getThumbGif();
        String thumb = childBean.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            MyUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }
        holder.itemFavorite.setSelected(true);
        holder.layoutFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.itemFavorite.setSelected(false);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);
                if (mCallBack != null) {
                    mCallBack.OnRemoveLike(childBean);
                }
            }
        });
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, SetkeyboardActivity.class);
                intentApply.putExtra(SetkeyboardActivity.SOURCE_KEY, childBean);
                intentApply.putExtra(SetkeyboardActivity.DISPLAY_URL_KEY, childBean.getImgPath());
                intentApply.putExtra(SetkeyboardActivity.ZIP_URL_KEY, childBean.getZipPath());
                intentApply.putExtra(SetkeyboardActivity.NAME_KEY, childBean.getTitleName());
                intentApply.putExtra(SetkeyboardActivity.GIF_KEY, childBean.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(SetkeyboardActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private FrameLayout layoutFavorite;
        private ImageView itemImg, itemFavorite;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            layoutFavorite = itemView.findViewById(R.id.layout_favorite);
            itemImg = itemView.findViewById(R.id.im);
            itemFavorite = itemView.findViewById(R.id.im_favorite);

        }

    }

}
